#ifndef _defs_h_included_
#define _defs_h_included_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "utils.h"

#define TRUE 1
#define FALSE 0

#define maxOpNum 64
#define bitNum 32
#define maxRegNum 128
#define maxLabelNum 1024

char* source;
char* dest ;
char* opcode_file;
char* register_file;
int opNum, regNum, labelNum;

extern int parse(char input[], char *arg[]);

int load_table(char path[], char **op[]);
int saveLabels(char *labelName, int lineNum, char **label[]);
int getLabels(int lineNum, char *cmdLine[], char **op[], char **label[]);
int assemble(int lineNum, char *cmdLine[], int cmdLength, char **op[], char **reg[], char **label[], FILE *fd);

#endif
