#include "asl.h"

void reverse_char(char *a, unsigned long len) {
	unsigned long i;
	char tmp;
	for (i = 0; i <= (len-1)/2 ; i++) {
		tmp = a[i];
		a[i] = a[len - 1 - i];
		a[len - 1 - i] = tmp;
	}
}

char *my_itoa(int a, char *buffer, int buff_size, int radix) {
	char *temp;
	int b;
	int len = buff_size;
	temp = buffer;

	b = a;
	if (buffer == NULL)
		return NULL;
	
	while (a > 0 || buff_size > 0) {
		if (buff_size < 1) return NULL;

		b = a % radix;
		*temp = b + '0';
		temp++;
		a = a / radix;
		buff_size--;
	}
	*temp = '\0';
	/*Note : You have to Add a String reverse Function on this buffer here*/
	reverse_char(buffer, len - buff_size);
	return buffer;
}

int get_code_from_string(char* buf)
{
	int x, i;
	x = 0;
	for (i = 0; i < 32; i++) {
		x <<= 1;
		if (buf[i] == '1') x |= 1;		
	}
	printf("buf = %s, x = %x\n", buf, x);
	return x;
}

int member(char c, char str[])
{
	int i;
  	int length = strlen(str);
  	for (i = 0; i < length; i++) {
    	if (c == str[i]) return TRUE;
  	}
  	return FALSE;
}
